<template>
    <div class="app-container">
<!--        <div class="filter-container">-->
<!--            <el-row>-->
<!--                <el-col :span="2">-->
<!--                    <div style="margin-top:10px">按区域查询：</div>-->
<!--                </el-col>-->
<!--                <el-col :span="3">-->
<!--                    <el-select v-model="searchForm.province" clearable filterable @change="changeArea('province')">-->
<!--                        <el-option-->
<!--                            v-for="item in provinceList"-->
<!--                            :key="item.id"-->
<!--                            :label="item.name"-->
<!--                            :value="item.name"-->
<!--                        >-->
<!--                        </el-option>-->
<!--                    </el-select>-->
<!--                </el-col>-->
<!--                <el-col :span="3">-->
<!--                    <el-select v-model="searchForm.city" prop="city" clearable filterable @change="changeArea('city')" class="emergencyResponsePlan_area">-->
<!--                        <el-option-->
<!--                            v-for="item in cityList"-->
<!--                            :key="item.id"-->
<!--                            :label="item.name"-->
<!--                            :value="item.name"-->
<!--                        >-->
<!--                        </el-option>-->
<!--                    </el-select>-->
<!--                </el-col>-->
<!--                <el-col :span="3">-->
<!--                    <el-select v-model="searchForm.district" clearable filterable @change="changeArea('district')" class="emergencyResponsePlan_area">-->
<!--                        <el-option-->
<!--                            v-for="item in districtList"-->
<!--                            :key="item.id"-->
<!--                            :label="item.name"-->
<!--                            :value="item.name"-->
<!--                        >-->
<!--                        </el-option>-->
<!--                    </el-select>-->
<!--                </el-col>-->
<!--                <el-col :span="3">-->
<!--                    <el-select v-model="searchForm.street"clearable filterable @change="changeArea('street')" class="emergencyResponsePlan_area">-->
<!--                        <el-option-->
<!--                            v-for="item in streetList"-->
<!--                            :key="item.id"-->
<!--                            :label="item.name"-->
<!--                            :value="item.name"-->
<!--                        >-->
<!--                        </el-option>-->
<!--                    </el-select>-->
<!--                </el-col>-->
<!--                <el-col :span="3">-->
<!--                    <el-select v-model="searchForm.committee" clearable filterable class="emergencyResponsePlan_area">-->
<!--                        <el-option-->
<!--                            v-for="item in committeeList"-->
<!--                            :key="item.id"-->
<!--                            :label="item.name"-->
<!--                            :value="item.name"-->
<!--                        >-->
<!--                        </el-option>-->
<!--                    </el-select>-->
<!--                </el-col>-->
<!--            </el-row>-->
<!--            <el-row style="padding-top: 10px">-->
<!--                <el-col :span="2">-->
<!--                    <div style="margin-top:10px">按监管分类：</div>-->
<!--                </el-col>-->
<!--                <el-col :span="3">-->
<!--                    <el-select v-model="searchForm.type" clearable filterable @change="changeArea('province')">-->
<!--                        <el-option-->
<!--                            v-for="item in provinceList"-->
<!--                            :key="item.id"-->
<!--                            :label="item.name"-->
<!--                            :value="item.name"-->
<!--                        >-->
<!--                        </el-option>-->
<!--                    </el-select>-->
<!--                </el-col>-->
<!--                <el-col :span="3">-->
<!--                    <div style="margin-top:10px;margin-left:10px">按企业名称查询：</div>-->
<!--                </el-col>-->
<!--                <el-col :span="5">-->
<!--                    <el-input v-model="searchForm.name" clearable filterable @change="changeArea('province')">-->
<!--                    </el-input>-->
<!--                </el-col>-->
<!--                <el-col :span="5" style="margin-left:10px">-->
<!--                    <el-button  type="primary"  @click="queryHandle" align="right">上传文件模板</el-button>-->
<!--                </el-col>-->
<!--            </el-row>-->
<!--        </div>-->
        <div class="filter-container">
            <el-button class="filter-item" style="margin-left: 10px;" type="primary"  @click="openEmergencyForm('新增','')">添加</el-button>
        </div>
        <div class="table_content">
            <el-table
                v-loading="listLoading"
                :key="tableKey"
                :data="emergencyDataList"
                border
                fit
                highlight-current-row
                style="width: 100%;"
            >
                <el-table-column label="序号" type="index" align="center" width="60"/>
                <el-table-column label="制度名称" prop="name" align="center">
                </el-table-column>
                <el-table-column label="制定时间" prop="settime" align="center">
                </el-table-column>
                <el-table-column label="上传时间" prop="createtime" align="center">
                </el-table-column>
                <el-table-column label="操作" align="center" width="180" class-name="small-padding fixed-width">
                    <template slot-scope="scope">
                        <el-button type="text" @click="openEmergencyForm('修改',scope.row)">修改</el-button>
                        <el-button type="text" @click="download('下载',scope.row)">下载</el-button>
                        <el-button type="text" @click="deleteById(scope.row)">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <br>
            <el-pagination
                v-show="recordTotal>0"
                :current-page="currentPage"
                :page-sizes="[10, 20, 30, 50]"
                :page-size="pageSize"
                :total="recordTotal"
                layout="total, sizes, prev, pager, next, jumper"
                background
                style="float:right;"
                @size-change="handleSizeChange"
                @current-change="handleCurrentChange"/>
        </div>
        <emergencyPlan ref="emergencyPlan" @getinfo="getEmergencyData"></emergencyPlan>
    </div>
</template>

<script>
import emergencyPlan from "./components/emergencyPlan";
import { computePageCount } from '@/utils'
import {  getEmergencyList , deleteEmergency} from '@/api/emergency'
import {getCityListData, getProvinceListData} from "../../../api/area";
import {uploadUrl} from '@/assets/upload/url'
export default {
    name: "publicSecurityDepartment",
    props:["enterpriseId"],
    data(){
        return{
            tableKey:0,
            listLoading:false,
            pageSize: 10,
            recordTotal: 0,
            currentPage: 1,
            pageTotal: 0,
            searchContent:'',
            provinceList:[],
            cityList:[],
            districtList:[],
            streetList:[],
            committeeList:[],
            emergencyDataList:[],
            searchForm:{
                province:'',
                city:'',
                district:'',
                street:'',
                committee:'',
                type:'',
            }
        }
    },
    components:{
        emergencyPlan
    },
    created(){
        this.getEmergencyData()
        this.getProvince()
    },
    methods:{
        async getEmergencyData(){
            const params = {}
            params['pageIndex'] = this.currentPage
            params['pageSize'] = this.pageSize
            this.listLoading = true
            let res = await getEmergencyList(params,this.enterpriseId,"RESCUE")
            if(res.data.code === "200"){
                this.recordTotal = res.data.result.total
                this.pageSize = res.data.result.size
                this.pageTotal = computePageCount(res.data.result.total, res.data.result.size)
                this.currentPage = res.data.result.current
                this.emergencyDataList = res.data.result.records
            }else{
                this.$message({
                    type:'warning',
                    message:res.data.message
                })
            }
            this.listLoading = false
        },
        openEmergencyForm(title,value){
            this.$refs.emergencyPlan.showEmergencyForm(title,value,this.enterpriseId)
        },
        deleteById(row){
            this.$confirm('删除此条信息，是否继续','提示',{
                confirmButtonText:'确定',
                cancelButtonText:'取消',
                type:'warning',
            }).then(()=> {
                deleteEmergency(row.id).then( ()=>{
                    this.getEmergencyData()
                    this.$notify({
                        title:'成功',
                        message:'删除成功',
                        type:'success',
                        duration:2000,
                    })
                })
            })
        },
        async getProvince(){
            let res = await getProvinceListData()
            if(res.data.code === "200"){
                this.provinceList = res.data.result.provinceList
            }
        },
        async changeArea(value){
            if(value === 'province'){
                this.searchForm.city = ''
                this.searchForm.district = ''
                this.searchForm.street = ''
                this.searchForm.committee = ''
                this.areaListQuery = {
                    type: 2,
                    parenttype: 1,
                    parentname: this.searchForm.province,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.cityList = res.data.result
                }
            }else if(value === 'city'){
                this.searchForm.district = ''
                this.searchForm.street = ''
                this.searchForm.committee = ''
                this.areaListQuery = {
                    type: 3,
                    parenttype: 2,
                    parentname: this.searchForm.city,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.districtList = res.data.result
                }
            }else if(value === 'district'){
                this.searchForm.street = ''
                this.searchForm.committee = ''
                this.areaListQuery = {
                    type: 4,
                    parenttype: 3,
                    parentname: this.searchForm.district,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.streetList = res.data.result
                }
            }else if(value === 'street'){
                this.searchForm.committee = ''
                this.areaListQuery = {
                    type: 5,
                    parenttype: 4,
                    parentname: this.searchForm.street,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.committeeList = res.data.result
                }
            }
        },
        download(title,row){
            window.open(uploadUrl()+row.enterpriseResources[0].url, '_blank')
        },
        refreshHandle(){

        },
        queryHandle(){
            this.getEmergencyData()
        },
        handleSizeChange(val) {
            this.listQuery.pageSize = val
            this.getEmergencyData()
        },
        handleCurrentChange(val) {
            this.listQuery.pageIndex = val
            this.getEmergencyData()
        },
    }
}
</script>

<style scoped>
.emergencyResponsePlan_area{
    margin-left: 10px;
}
</style>
